﻿
namespace _01_XamlEditor.Types
{
	using Windows.UI.Xaml;
	using Windows.UI.Xaml.Controls;
	using Windows.UI.Xaml.Media;

	public class ImageButton : Button
	{
		#region ImageSource

		/// <summary>
		/// ImageSource Dependency Property
		/// </summary>
		public static readonly DependencyProperty ImageSourceProperty = DependencyProperty.Register("ImageSource", typeof(ImageSource), typeof(ImageButton), new PropertyMetadata(null));

		/// <summary>
		/// Gets or sets the ImageSource property. This dependency property 
		/// indicates ....
		/// </summary>
		public ImageSource ImageSource
		{
			get { return (ImageSource)GetValue(ImageSourceProperty); }
			set { SetValue(ImageSourceProperty, value); }
		}

		#endregion

		#region ImagePadding

		/// <summary>
		/// ImagePadding Dependency Property
		/// </summary>
		public static readonly DependencyProperty ImagePaddingProperty = DependencyProperty.Register("ImagePadding", typeof(Thickness), typeof(ImageButton), new PropertyMetadata(new Thickness(0, 0, 0, 0)));

		/// <summary>
		/// Gets or sets the ImagePadding property. This dependency property 
		/// indicates ....
		/// </summary>
		public Thickness ImagePadding
		{
			get { return (Thickness)GetValue(ImagePaddingProperty); }
			set { SetValue(ImagePaddingProperty, value); }
		}

		#endregion

		#region ImageStretch

		/// <summary>
		/// ImageStretch Dependency Property
		/// </summary>
		public static readonly DependencyProperty ImageStretchProperty =
			 DependencyProperty.Register("ImageStretch", typeof(Stretch), typeof(ImageButton),
				  new PropertyMetadata(Stretch.None));

		/// <summary>
		/// Gets or sets the ImageStretch property. This dependency property 
		/// indicates ....
		/// </summary>
		public Stretch ImageStretch
		{
			get { return (Stretch)GetValue(ImageStretchProperty); }
			set { SetValue(ImageStretchProperty, value); }
		}

		#endregion

	}
}
