﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using _03_Blend.Entities;
using _03_Blend.Infrastructure;
using _03_Blend.Services;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace _03_Blend.ViewModels
{
   public class MainPageViewModel : ViewModelBase
   {
      private DataProvider dataProvider;
      private ApplicationController applicationController;

      public MainPageViewModel(DataProvider dataProvider, ApplicationController applicationController)
      {
         this.dataProvider = dataProvider;
         this.applicationController = applicationController;
         this.Sections = new ObservableCollection<HomePageSection>(dataProvider.GetSections());
         this.SectionSelectedCommand = new RelayCommand<HomePageSection>((p) => this.OnSectionSelected(p));
      }

#if DEBUG
      public MainPageViewModel()
      {
         if (!this.IsInDesignMode) throw new InvalidOperationException("Available only in design time mode...");
         this.Sections = new ObservableCollection<HomePageSection>();

         HomePageSection section1 = new HomePageSection() { Content = "Lorem ipsum dolor sit amet, probatus imperdiet nec ut, mea prima mundi causae et, vim nibh abhorreant et. Mei fugit essent neglegentur ad, congue virtute scaevola mea ut, vis doming perpetua ei. Consul ignota noluisse eum eu, vix liber delicatissimi ex, tation consulatu usu at.", Header = "Tablet 1", ImageUri = new Uri("ms-appx:///Assets/Images/SurfaceRT.jpg") };
         HomePageSection section2 = new HomePageSection() { Content = "Ad clita admodum qui. Vel inermis officiis in, pro dicam insolens periculis ne. In semper invidunt vim, eum ad posse gubergren. Vim ei adhuc tempor principes, et est novum semper. Nec an erat mentitum, et homero convenire corrumpit est. Pro ex oratio inermis consequuntur, sea ubique placerat et, sea ut tibique lucilius", Header = "Tablet 2", ImageUri = new Uri("ms-appx:///Assets/Images/XPSDuo.jpg") };
         HomePageSection section3 = new HomePageSection() { Content = "Ei duo congue tantas copiosae, est ex quodsi mediocrem prodesset. Suscipit scripserit ea per, eum et eirmod appareat placerat, nam lorem vivendo ne. Ei veritus interesset cum. Vim modo solet persequeris id, usu no ceteros legendos, mei meliore eligendi cotidieque ei. Sit ne decore populo primis, an mea partem delicata", Header = "Tablet 3", ImageUri = new Uri("ms-appx:///Assets/Images/vivotab.jpg") };

         this.Sections.Add(section1);
         this.Sections.Add(section2);
         this.Sections.Add(section3);
      }
#endif

      public ObservableCollection<HomePageSection> Sections { get; set; }

      public ICommand SectionSelectedCommand { get; set; }

      private void OnSectionSelected(HomePageSection selectedSection)
      {
         this.applicationController.SelectedSection = selectedSection;
         (Window.Current.Content as Frame).Navigate(typeof(TabletDetailPage));
      }
   }
}
